if(!window.ChartUtils){var ChartUtils=(function(){"use strict";if(!Object.hasOwnProperty("init")){Object.init=function(proto,properties){if(arguments.length!==2){throw new Error('Object.init implementation only accepts 2 parameters.');}var key,new_obj=Object.create(proto);if(properties){for(key in properties){if(properties.hasHownProperty(key)){Object.defineProperty(new_obj,key,{value:properties[key],writable:true,enumerable:true,configurable:false});}}}return new_obj;};}if(Object.prototype.clear){Object.prototype.clear=function(){for(var prop in this){if(this.hasOwnProperty(prop)){delete this[prop];}}return this;};}function addPublicMethod(methodName,method){if(!methodName||!method){throw"Wrong number of arguments Exception";}if(!Object.isString(methodName)){throw"Illegal Argument Exception: methodName must be a string";}if(!Object.isFunction(method)){throw"Illegal Argument Exception: method must be a function";}Object.defineProperty(this,methodName,{value:method,writable:false,enumerable:true,configurable:false});return this;}if(!Object.prototype.addPublicMethod){Object.defineProperty(Object.prototype,"addPublicMethod",{value:addPublicMethod,writable:false,enumerable:false,configurable:false});}function addProtectedMethod(methodName,method){if(!methodName||!method){throw"Wrong number of arguments Exception";}if(!Object.isString(methodName)){throw"Illegal Argument Exception: methodName must be a string";}if(!Object.isFunction(method)){throw"Illegal Argument Exception: method must be a function";}Object.defineProperty(this,methodName,{value:method,writable:false,enumerable:false,configurable:false});}if(!Object.prototype.addProtectedMethod){Object.defineProperty(Object.prototype,"addProtectedMethod",{value:addProtectedMethod,writable:false,enumerable:false,configurable:false});}if(!Object.prototype.createSafeProxy){Object.prototype.createSafeProxy=function(canDestroy){var property;var proxy=Object.create(null);var obj=this;for(property in obj){if(Object.isFunction(obj[property])){proxy[property]=(function(p){return function(){var result;if(obj){result=obj[p].apply(obj,Array.prototype.slice.apply(arguments,[0]));if(result===obj){return proxy;}else{return result;}}else{throw"Null reference: the object has been already destroyed";}};})(property);}}proxy.destroy=function(){try{if(canDestroy){obj.destroy();}}finally{obj=null;}};return proxy;};}function superMethod(methodName){if(!methodName){throw"Wrong number of arguments Exception";}if(!Object.isString(methodName)){throw"Illegal Argument Exception: methodName must be a string";}var proto=this.prototype&&this.prototype[methodName]?this.prototype:this.__proto__;if(proto&&proto[methodName]&&Object.isFunction(proto[methodName])){return proto[methodName].apply(proto,Array.prototype.slice.apply(arguments,[1]));}else{throw"Super object has no method "+methodName;}}if(!Object.prototype.superMethod){Object.defineProperty(Object.prototype,"superMethod",{value:superMethod,writable:false,enumerable:false,configurable:false});}function setProperty(property,value){if(!property){throw"Wrong number of arguments Exception";}if(!Object.isString(property)){throw"Illegal Argument Exception: property must be a string";}if(this.hasOwnProperty(property)){this[property]=value;return this;}var proto=this.prototype&&this.prototype[property]?this.prototype:this.__proto__;if(proto&&!Object.isUndefined(proto[property])){proto.setProperty(property,value);return this;}else{throw"Super object has no property "+property;}}if(!Object.prototype.setProperty){Object.defineProperty(Object.prototype,"setProperty",{value:setProperty,writable:false,enumerable:false,configurable:false});}if(Array.prototype.clear){Array.prototype.clear=function(deepClear){if(deepClear){for(var i=0;i<this.length;i++){if(Object.isFunction(this[i].clear)){this[i].clear();}}}this.length=0;return this;};}if(!Array.prototype.map){Array.prototype.map=function(f){if(!Function.isFunction(f)){throw new TypeError();}else{var len=this.length;var res=new Array(len);var contest=arguments[1];for(var i=0;i<len;i++){if(i in this){res[i]=f.call(contest,this[i],i,this);}}return res;}};}if(!Array.prototype.sum){Array.prototype.sum=function(){var len=this.length;var res=0;for(var i=0;i<len;i++){res+=this[i];}return res;};}if(!Array.prototype.shallowCopy){Array.prototype.shallowCopy=function(n){var len=this.length;if(Object.isUndefined(n)){n=len;}else{n=parseInt(n,10);if(isNaN(n)||n<=0){throw"Invalid argument: n";}else{n=Math.min(n,len);}}var res=new Array(n);for(var i=0;i<n;i++){res[i]=this[i];}return res;};}if(!Array.prototype.max){Array.prototype.max=function(extract_element_key){if(Function.isFunction(extract_element_key)){return Math.max.apply(Math,this.map(extract_element_key));}else{return Math.max.apply(Math,this);}};}if(!Array.prototype.min){Array.prototype.min=function(extract_element_key){if(Function.isFunction(extract_element_key)){return Math.min.apply(Math,this.map(extract_element_key));}else{return Math.min.apply(Math,this);}};}if(!Object.prototype.isArray){Object.prototype.isArray=function(obj){return obj&&(obj.constructor===Array);};}if(!Object.prototype.isString){Object.prototype.isString=function(arg){return typeof(arg)==='string';};}if(!Object.prototype.isFunction){Object.prototype.isFunction=function(arg){return typeof(arg)==='function';};}if(!Object.prototype.isNumber){Object.prototype.isNumber=function(n){return!isNaN(parseFloat(n))&&isFinite(n);};}if(!Object.prototype.isUndefined){Object.prototype.isUndefined=function(arg){return typeof(arg)==="undefined";};}if(!Object.prototype.shallowCopy){Object.prototype.shallowCopy=function(){var res={};for(var key in this){if(this.hasOwnProperty(key)){res[key]=this[key];}}return res;};}var TIME_REGEXP=/^\d\d?:\d\d?$/;function formatTimeString(HH,MM){HH=(HH+Math.floor(MM/60))%24;MM=MM%60;return(HH<10?"0"+HH:HH)+":"+(MM<10?"0"+MM:MM);}var SUFFIXES=["","K","M","G","T","P","E"];var utils={abbreviateNumber:function(val){var index;if(val===0){return"0";}if(Math.abs(val)<1){index=0;while(Math.abs(val)<1){index+=1;val*=10;}return(Math.round(val*100)/100.0)+"e-"+index;}else{index=0;while(index<SUFFIXES.length-1){if(Math.abs(val)<1000){if(index===0){val=Math.round(val*100.0)/100.0;}return val+SUFFIXES[index];}else{index+=1;val=Math.round(val/100.0)/10.0;}}if(Math.abs(val)<1000){return val+SUFFIXES[index];}else{return val+SUFFIXES[SUFFIXES.length-1];}}},fillArray:function(value,n){n=parseInt(n,10);if(isNaN(n)||n<=0){throw"Invalid Argument: n";}var i,res=new Array(n);if(Function.isFunction(value)){for(i=0;i<n;i++){res[i]=value();}}else{for(i=0;i<n;i++){res[i]=value;}}return res;},validateTimeString:function(timeString){if(!TIME_REGEXP.test(timeString)){return null;}var v=timeString.split(":").map(function(s){return parseInt(s,10);});if(v[0]>=24||v[1]>=60){return null;}else{return v;}},addTimeStrings:function(timeString_1,timeString_2){var t1=this.validateTimeString(timeString_1);if(!t1){throw"Invalid Argument: timeString_1";}var t2=this.validateTimeString(timeString_2);if(!t2){throw"Invalid Argument: timeString_2";}t1[1]+=t2[1];t1[0]+=t2[0];return formatTimeString(t1[0],t1[1]);},addIntToTimeString:function(timeString,minutes){var t=this.validateTimeString(timeString);if(!t){throw"Invalid Argument: timeString";}if(minutes<0){throw"Invalid Argument: minutes";}t[1]+=minutes;return formatTimeString(t[0],t[1]);}};Object.freeze(utils);return utils;})();}
if(!window.DynamicChart){var DynamicChart=(function(){"use strict";var MAX_SPACE_DIMENSION=10;var FILL_COLORS=["blue","red","green","orange","purple","cyan","magenta","yellow","limegreen","brown"];var DEFAULT_LABEL_SIZE=12;var DEFAULT_TITLE_SIZE=22;var DEFAULT_AXE_MARGIN=25;var DEFAULT_INNER_BACKGROUND="white";var DEFAULT_OUTER_BACKGROUND="white";var DEFAULT_INNER_BORDER={fill:"none",width:0,dash:null};var DEFAULT_OUTER_BORDER={fill:"none",width:0,dash:null};var DEFAULT_AXES_LABEL_SIZE=12;var NOTCH_LINE_LENGTH=5;var DEFAULT_AXES_LINE_WIDTH=1;var DEFAULT_AXES_COLOR="black";var LEGEND_ITEM_WIDTH=25,LEGEND_ITEM_HEIGHT=15,LEGEND_MARGIN=5,LEGEND_ITEM_LEFT=LEGEND_MARGIN,LEGEND_ITEM_FONT_SIZE=11;var legendPrototype={setPosition:function(left,top){left=parseInt(left,10);top=parseInt(top,10);if(this.__divElement__&&!isNaN(left)&&!isNaN(top)){this.__divElement__.attr("style","position:absolute; left:"+left+"px; top:"+top+"px;");}return this;},setWidth:function(width){width=parseInt(width,10);if(this.__svgElement__&&!isNaN(width)&&width>=0){this.__svgElement__.attr("width",width);this.__divElement__.attr("width",width);}else{throw"Illegal Argument: width";}return this;},setHeight:function(height){height=parseInt(height,10);if(this.__svgElement__&&!isNaN(height)&&height>=0){this.__svgElement__.attr("height",height);}else{throw"Illegal Argument: height";}return this;},addItem:function(labelText,labelColor,fillColor){if(Object.isUndefined(labelText)||Object.isUndefined(labelColor)||Object.isUndefined(fillColor)){throw"Wrong number of arguments: label and color are both mandatory";}this.__items__.push({labelText:labelText,labelColor:labelColor,fillColor:fillColor});var n=this.__items__.length-1;this.__svgElement__.append("rect").attr("stroke","black").attr("fill",fillColor).attr("width",LEGEND_ITEM_WIDTH).attr("height",LEGEND_ITEM_HEIGHT).attr("x",LEGEND_ITEM_LEFT).attr("y",LEGEND_MARGIN+n*(LEGEND_ITEM_HEIGHT+LEGEND_MARGIN));this.__svgElement__.append("text").text(labelText).attr("fill",labelColor).attr("x",LEGEND_ITEM_LEFT+LEGEND_ITEM_WIDTH+LEGEND_MARGIN).attr("y",n*(LEGEND_ITEM_HEIGHT+LEGEND_MARGIN)+LEGEND_ITEM_HEIGHT).attr("font-family","sans-serif").attr("font-size",LEGEND_ITEM_FONT_SIZE).attr("text-anchor","left");},removeItem:function(index){index=parseInt(index,10);if(isNaN(index)||index<0||index>=this.__items__.length){throw"Illegal Argument: index";}this.__items__.splice(index,1);this.__svgElement__.selectAll("rect").data(this.__items__).exit().remove();this.__svgElement__.selectAll("text").data(this.__items__).exit().remove();this.__redrawLegend__();return this;},updateItem:function(index,newLabelText,newLabelColor,newFillColor){index=parseInt(index,10);if(isNaN(index)||index<0||index>=this.__items__.length){throw"Illegal Argument: index";}var oldItem=this.__items__[index];if(!Object.isUndefined(newLabelText)){oldItem.labelText=newLabelText;}if(!Object.isUndefined(newLabelColor)){oldItem.labelColor=newLabelColor;}if(!Object.isUndefined(newFillColor)){oldItem.fillColor=newFillColor;}this.__redrawLegend__();return this;},destroy:function(){this.__items__.length=0;this.__svgElement__.remove();this.__divElement__.remove();return null;}};function LegendFactory(width,height,left,top,parent){function __init__(legend,width,height,left,top){legend.setWidth(width);legend.setHeight(height);if(Object.isUndefined(left)){left=0;}if(Object.isUndefined(top)){top=0;}legend.setPosition(left,top);legend.__svgElement__.append("rect").attr("stroke","black").attr("width",width).attr("fill","white").attr("height",height-2).attr("x",0).attr("y",1);}var legend=Object.create(legendPrototype);Object.defineProperty(legend,"__redrawLegend__",{value:function(){this.__svgElement__.selectAll("rect").data(this.__items__).attr("stroke","black").attr("fill",function(item){return item.fillColor;}).attr("width",LEGEND_ITEM_WIDTH).attr("height",LEGEND_ITEM_HEIGHT).attr("x",LEGEND_ITEM_LEFT).attr("y",function(item,i){return LEGEND_MARGIN+i*(LEGEND_ITEM_HEIGHT+LEGEND_MARGIN);});this.__svgElement__.selectAll("text").data(this.__items__).text(function(item){return item.labelText;}).attr("fill",function(item){return item.labelColor;}).attr("x",LEGEND_ITEM_LEFT+LEGEND_ITEM_WIDTH+LEGEND_MARGIN).attr("y",function(item,i){return i*(LEGEND_ITEM_HEIGHT+LEGEND_MARGIN)+LEGEND_ITEM_HEIGHT;}).attr("font-family","sans-serif").attr("font-size",LEGEND_ITEM_FONT_SIZE).attr("text-anchor","left");return;},writable:false,enumerable:false,configurable:false});if(Object.isUndefined(width)||Object.isUndefined(height)){throw"Wrong number of arguments: width and height are mandatory";}if(Object.isUndefined(parent)){parent=d3.select("body");}var div=parent.append("div");var svg=div.append("svg").attr("id","chart_legend");Object.defineProperty(legend,"__divElement__",{value:div,writable:false,enumerable:false,configurable:false});Object.defineProperty(legend,"__svgElement__",{value:svg,writable:false,enumerable:false,configurable:false});Object.defineProperty(legend,"__items__",{value:[],writable:false,enumerable:false,configurable:false});__init__(legend,width,height,left,top);Object.seal(legend);return legend;}var next_id=0;var basicBarChartSharedPrototype={setPosition:function(left,top){left=parseInt(left,10);top=parseInt(top,10);if(this.__divElement__&&!isNaN(left)&&!isNaN(top)){this.__divElement__.attr("style","position:absolute; left:"+left+"px; top:"+top+"px;");}return this;},setWidth:function(width){width=parseInt(width,10);if(this.__svgElement__&&!isNaN(width)&&width>=0){this.__svgElement__.attr("width",width);this.__divElement__.attr("width",width);}else{throw"Illegal Argument: width";}return this;},setHeight:function(height){height=parseInt(height,10);if(this.__svgElement__&&!isNaN(height)&&height>=0){this.__svgElement__.attr("height",height);this.__divElement__.attr("height",height);}else{throw"Illegal Argument: height";}return this;},getAxesWidth:function(){return[this.__svgElement__.select("#axe_top").attr("width"),this.__svgElement__.select("#axe_right").attr("width"),this.__svgElement__.select("#axe_bottom").attr("width"),this.__svgElement__.select("#axe_left").attr("width")];},getAxesHeight:function(){return[this.__svgElement__.select("#axe_top").attr("height"),this.__svgElement__.select("#axe_right").attr("height"),this.__svgElement__.select("#axe_bottom").attr("height"),this.__svgElement__.select("#axe_left").attr("height")];},setTitle:function(title,size,color,left,top){var titleElement=this.__axeTop__.selectAll("text[type=title_element]");size=parseInt(size,10);if(!Object.isNumber(size)){size=DEFAULT_TITLE_SIZE;}left=parseInt(left,10);if(!Object.isNumber(left)){left=this.__axeTop__.attr("width")/2;}top=parseInt(top,10);if(!Object.isNumber(top)){top=size;}if(Object.isUndefined(color)){color="black";}if(titleElement.empty()){titleElement=this.__axeTop__.append("text").attr("type","title_element").attr("text-anchor","middle").attr("font-family","sans-serif");}titleElement.text(title).attr("font-size",size).attr("x",left).attr("y",top).attr("fill",color);return this;},addLegend:function(labels,width,height,left,top,parent){if(this.hasOwnProperty("__legend__")){if(!Object.isArray(labels)){throw"Illegal Argument: labels";}else if(labels.length!==this.__dataDim__){throw"Invalid array size: "+this.__dataDim__+" labels needed";}if(this.__legend__&&this.__legend__.destroy){this.__legend__.destroy();}if(Object.isUndefined(parent)){parent=this.__parent__;}this.__legend__=LegendFactory(width,height,left,top,parent);for(var i=0;i<labels.length;i++){this.__legend__.addItem(labels[i],this.getLabelColor(i),this.getBarsFillColor(i));}}else{var proto=this.prototype?this.prototype:this.__proto__;if(proto&&proto.addLegend){proto.addLegend(labels,width,height,left,top,parent);}}return this;},appendData:function(newDataArray){var oldDataLength=Math.max(this.__dataDim__,this.__getDatasetLength__()*this.__dataDim__);newDataArray=this.__canAppendData__(newDataArray);var i,j,val;if(Object.isArray(newDataArray)){var n=newDataArray.length;for(i=0;i<n;i++){val=this.__formatValue__(newDataArray[i]);if(val!==null){this.setProperty("__dataCounter__",this.__dataCounter__+1);for(j=0;j<this.__dataDim__;j++){this.__data__[j].push(val[j]);if(val[j]>this.__maxVals__[j]){this.__maxVals__[j]=val[j];}}}}}else{throw"Illegal Argument: newDataArray must be an Array";}var newDataLength=this.__getDatasetLength__()*this.__dataDim__;var max_val;if(this.__scaleGlobally__){max_val=ChartUtils.fillArray(this.__maxVals__.max(),this.__dataDim__);}else{max_val=this.__maxVals__;}this.__updateBackground__();for(j=0;j<this.__dataDim__;j++){this.__xScale__.domain([0,oldDataLength]);var dataSet=this.__selectData__(this.__data__,j);var labelsSet=this.__selectLabels__(this.__data__,j);this.__drawNewData__(dataSet,labelsSet,j,this.__xScale__,this.__yScale__[j]);this.__xScale__.domain([0,newDataLength]);this.__yScale__[j].domain([0,max_val[j]]);this.__updateDrawing__(dataSet,labelsSet,j,this.__xScale__,this.__yScale__[j]);}this.__updateAxes__(this.__yScale__[0]);return this;},setFormatValueFunction:function(formaValueFunction){if(Object.isUndefined(formaValueFunction)||!Object.isFunction(formaValueFunction)){throw"Illegal Argument: formaValueFunction";}Object.defineProperty(this,"__formatValue__",{value:formaValueFunction,writable:true,enumerable:false,configurable:false});return this;},clearData:function(n){var i,dataSet,labelsSet;if(!Object.isUndefined(n)){n=parseInt(n,10);if(isNaN(n)||n<=0||n>this.__getDatasetLength__()){throw"Illegal Argument: n";}}else{n=this.__getDatasetLength__();}for(i=0;i<this.__dataDim__;i++){dataSet=this.__selectData__(this.__data__,i,n);labelsSet=this.__selectLabels__(this.__data__,i,n);this.__clearDrawing__(dataSet,labelsSet);this.__data__[i].splice(0,n);this.__maxVals__[i]=this.__data__[i].max();}this.__onClearData__(n);return this;},toggleLabels:function(index,visible){if(!index){index=0;}else{index=parseInt(index,10);}if(!isNaN(index)&&index>=0&&this.__labelsVisible__.length>index){if(!Object.isUndefined(visible)){this.__labelsVisible__[index]=visible?true:false;}else{this.__labelsVisible__[index]=!this.__labelsVisible__;}}else{throw"Invalid Index";}return this;},areLabelsVisible:function(index){if(!index){index=0;}else{index=parseInt(index,10);}if(!isNaN(index)&&index>=0&&this.__labelsVisible__.length>index){return this.__labelsVisible__[index];}else{throw"Invalid Index";}},setGlobalScaling:function(){if(this.hasOwnProperty("__scaleGlobally__")){this.__scaleGlobally__=true;}else{var proto=this.prototype?this.prototype:this.__proto__;if(proto&&proto.setGlobalScaling){proto.setGlobalScaling();}}return this;},setLocalScaling:function(){if(this.hasOwnProperty("__scaleGlobally__")){this.__scaleGlobally__=false;}else{var proto=this.prototype?this.prototype:this.__proto__;if(proto&&proto.setLocalScaling){proto.setLocalScaling();}}return this;},getBarsFillColor:function(index){if(!index){index=0;}else{index=parseInt(index,10);}if(!isNaN(index)&&index>=0&&this.__barsFillColors__.length>index){return this.__barsFillColors__[index];}else{throw"Invalid Index";}},getBarsStrokeColor:function(index){if(!index){index=0;}else{index=parseInt(index,10);}if(!isNaN(index)&&index>=0&&this.__barsStrokeColors__.length>index){return this.__barsStrokeColors__[index];}else{throw"Invalid Index";}},getLabelColor:function(index){if(!index){index=0;}else{index=parseInt(index,10);}if(!isNaN(index)&&index>=0&&this.__labelColors__.length>index){return this.__labelColors__[index];}else{throw"Invalid Index";}},getLabelsSize:function(index){if(!index){index=0;}else{index=parseInt(index,10);}if(!isNaN(index)&&index>=0&&this.__labelsSize__.length>index){return this.__labelsSize__[index];}else{throw"Invalid  Index";}},getBarWidth:function(xScale){if(Object.isUndefined(xScale)){xScale=this.__xScale__;}if(!xScale){throw"Illegal Argument: xScale";}return xScale(1)-xScale(0)-1;},getOuterBackgroundColor:function(){return this.__outerBackgroundColor__;},getInnerBackgroundColor:function(){return this.__innerBackgroundColor__;},getInnerBorder:function(){return this.__innerBorder__;},getOuterBorder:function(){return this.__outerBorder__;},setBarsFillColor:function(color,index,superCall){if(!index){index=0;}else{index=parseInt(index,10);}if(!isNaN(index)&&index>=0&&this.__barsFillColors__.length>index){this.__barsFillColors__[index]=color;}else{throw"Invalid Index";}if(this.__legend__){this.__legend__.updateItem(index,undefined,undefined,color,true);}if(!superCall){this.__redrawAll__();}return this;},setBarsStrokeColor:function(color,index){if(!index){index=0;}else{index=parseInt(index,10);}if(!isNaN(index)&&index>=0&&this.__barsStrokeColors__.length>index){this.__barsStrokeColors__[index]=color;}else{throw"Invalid Index";}return this;},setLabelColor:function(color,index){if(!index){index=0;}else{index=parseInt(index,10);}if(!isNaN(index)&&index>=0&&this.__labelColors__.length>index){this.__labelColors__[index]=color;}else{throw"Invalid Index";}if(this.__legend__){this.__legend__.updateItem(index,undefined,color,undefined);}return this;},setLabelSize:function(size,index){size=parseInt(size,10);if(isNaN(size)||size<=0){throw"Illegal Argument: size";}if(!index){index=0;}else{index=parseInt(index,10);}if(!isNaN(index)&&index>=0&&this.__labelsSize__.length>index){this.__labelsSize__[index]=size;}else{throw"Invalid Index";}return this;},setBarWidth:function(){throw"Read only property: barWidth";},setInnerBackgroundColor:function(bgColor,superCall){if(this.hasOwnProperty("__innerBackgroundColor__")){this.__innerBackgroundColor__=bgColor;}else{this.superMethod("setInnerBackgroundColor",bgColor,true);}if(!superCall){this.__redrawInnerBackground__();}return this;},setOuterBackgroundColor:function(bgColor,superCall){if(this.hasOwnProperty("__outerBackgroundColor__")){this.__outerBackgroundColor__=bgColor;}else{this.superMethod("setOuterBackgroundColor",bgColor,true);}if(!superCall){this.__redrawOuterBackground__();}return this;},setInnerBorder:function(fill,width,dash,superCall){if(this.hasOwnProperty("__innerBorder__")){this.__innerBorder__.fill=fill;if(!Object.isUndefined(width)){this.__innerBorder__.width=width;}if(!Object.isUndefined(dash)){this.__innerBorder__.dash=dash;}}else{this.superMethod("setInnerBorder",fill,width,dash,true);}if(!superCall){this.__redrawInnerBorder__();}return this;},setOuterBorder:function(fill,width,dash,superCall){if(this.hasOwnProperty("__outerBorder__")){this.__outerBorder__.fill=fill;if(!Object.isUndefined(width)){this.__outerBorder__.width=width;}if(!Object.isUndefined(dash)){this.__outerBorder__.dash=dash;}}else{this.superMethod("setOuterBorder",fill,width,dash,true);}if(!superCall){this.__redrawOuterBorder__();}return this;},setAbbreviatedLabel:function(index,superCall){if(this.hasOwnProperty("__abbreviatedLabels__")){if(!index){index=0;}else{index=parseInt(index,10);}if(!isNaN(index)&&index>=0&&this.__abbreviatedLabels__.length>index){this.__abbreviatedLabels__[index]=true;}}else{this.superMethod("setAbbreviatedLabel",index,true);}if(!superCall){this.__redrawAll__();}return this;},setExtendedLabel:function(index,superCall){if(this.hasOwnProperty("__abbreviatedLabels__")){if(!index){index=0;}else{index=parseInt(index,10);}if(!isNaN(index)&&index>=0&&this.__abbreviatedLabels__.length>index){this.__abbreviatedLabels__[index]=false;}}else{this.superMethod("setExtendedLabel",index,true);}if(!superCall){this.__redrawAll__();}return this;},setHorizontalAxe:function(displayOnTop,title,notches,lineWidth,labelColor,labelSize,titleColor,titleSize){if(Object.isUndefined(notches)){notches=0;}else{notches=parseInt(notches,10);if(isNaN(notches)||notches<0){throw"Illegal Argument: notches";}}lineWidth=parseInt(lineWidth,10);if(isNaN(lineWidth)||lineWidth<=0){lineWidth=DEFAULT_AXES_LINE_WIDTH;}labelSize=parseInt(labelSize,10);if(isNaN(labelSize)||labelSize<=0){labelSize=DEFAULT_AXES_LABEL_SIZE;}if(Object.isUndefined(labelColor)){labelColor=DEFAULT_AXES_COLOR;}this.__clearHorizontalAxe__();var axe={notches:notches,color:labelColor,lineWidth:lineWidth,labelSize:labelSize,title:title,titleSize:parseInt(titleSize,10),titleColor:titleColor};if(displayOnTop){axe.side="top";axe.svgElement=this.__axeTop__;}else{axe.side="bottom";axe.svgElement=this.__axeBottom__;}if(isNaN(axe.titleSize)||axe.titleSize<0){axe.titleSize=DEFAULT_AXES_LABEL_SIZE;}if(!axe.titleColor){axe.titleColor=axe.color;}Object.freeze(axe);this.setProperty("__horizontalAxe__",axe);this.__drawHorizontalAxe__();return this;},removeHorizontalAxe:function(){this.__clearHorizontalAxe__();this.setProperty("__horizontalAxe__",null);return this;},setVerticalAxe:function(displayOnRight,title,notches,lineWidth,labelColor,labelSize,titleColor,titleSize){if(Object.isUndefined(notches)){notches=0;}else{notches=parseInt(notches,10);if(isNaN(notches)||notches<0){throw"Illegal Argument: notches";}}lineWidth=parseInt(lineWidth,10);if(isNaN(lineWidth)||lineWidth<=0){lineWidth=DEFAULT_AXES_LINE_WIDTH;}labelSize=parseInt(labelSize,10);if(isNaN(labelSize)||labelSize<=0){labelSize=DEFAULT_AXES_LABEL_SIZE;}if(Object.isUndefined(labelColor)){labelColor=DEFAULT_AXES_COLOR;}this.__clearVerticalAxe__();var axe={notches:notches,color:labelColor,lineWidth:lineWidth,labelSize:labelSize,title:title,titleSize:parseInt(titleSize,10),titleColor:titleColor};if(displayOnRight){axe.side="right";axe.svgElement=this.__axeRight__;}else{axe.side="left";axe.svgElement=this.__axeLeft__;}if(isNaN(axe.titleSize)||axe.titleSize<0){axe.titleSize=DEFAULT_AXES_LABEL_SIZE;}if(!axe.titleColor){axe.titleColor=axe.color;}Object.freeze(axe);this.setProperty("__verticalAxe__",axe);this.__drawVerticalAxe__(title,titleSize,titleColor);return this;},removeVerticalAxe:function(){this.__clearVerticalAxe__();this.setProperty("__verticalAxe__",null);return this;},destroy:function(){this.clearData();this.__data__.length=0;this.__maxVals__.length=0;this.__yScale__.length=0;this.__barsStrokeColors__.length=0;this.__barsFillColors__.length=0;this.__labelColors__.length=0;this.__labelsSize__.length=0;this.__labelsVisible__.length=0;this.__svgElement__.remove();this.__divElement__.remove();if(this.__legend__&&this.__legend__.destroy){this.__legend__.destroy();}return null;}};Object.defineProperty(basicBarChartSharedPrototype,"__getDatasetLength__",{value:function(){return this.__data__[0].length;},writable:false,enumerable:false,configurable:false});Object.defineProperty(basicBarChartSharedPrototype,"__canAppendData__",{value:function(newDataArray){if(!Object.isArray(newDataArray)){return[];}return this.__getDatasetLength__()===0||this.getBarWidth(this.__xScale__)>0?newDataArray:[];},writable:false,enumerable:false,configurable:false});basicBarChartSharedPrototype.addProtectedMethod("__redrawAll__",function __redrawAll__(){var dataSet,labelsSet;var newDataLength=this.__getDatasetLength__()*this.__dataDim__;var max_val;if(this.__scaleGlobally__){max_val=ChartUtils.fillArray(this.__maxVals__.max(),this.__dataDim__);}else{max_val=this.__maxVals__;}this.__xScale__.domain([0,newDataLength]);for(var i=0;i<this.__dataDim__;i++){this.__yScale__[i].domain([0,max_val[i]]);dataSet=this.__selectData__(this.__data__,i);labelsSet=this.__selectLabels__(this.__data__,i);this.__refreshDrawing__(dataSet,labelsSet,i,this.__xScale__,this.__yScale__[i]);}return;});Object.defineProperty(basicBarChartSharedPrototype,"__formatValue__",{value:function(value){if(Object.isArray(value)){if(value.length!==this.__dataDim__){return null;}for(var i=0;i<this.__dataDim__;i++){if(!Object.isNumber(value[i])){return null;}}return value.map(parseFloat);}else if(Object.isNumber(value)&&this.__dataDim__===1){return[parseFloat(value)];}else{return null;}},writable:false,enumerable:false,configurable:false});Object.defineProperty(basicBarChartSharedPrototype,"__selectData__",{value:function(data,index,n){if(Object.isUndefined(n)){return this.__chartArea__.selectAll("rect[index=data_"+index+"]").data(data[index]);}else{return this.__chartArea__.selectAll("rect[index=data_"+index+"]").data(data[index].slice(0,n));}},writable:false,enumerable:false,configurable:false});Object.defineProperty(basicBarChartSharedPrototype,"__selectLabels__",{value:function(data,index,n){if(Object.isUndefined(n)){return this.__chartArea__.selectAll("text[index=data_"+index+"]").data(data[index]);}else{return this.__chartArea__.selectAll("text[index=data_"+index+"]").data(data[index].slice(0,n));}},writable:false,enumerable:false,configurable:false});Object.defineProperty(basicBarChartSharedPrototype,"__drawNewData__",{value:function(dataSet,labelsSet,dataIndex,xScale,yScale){var that=this;var height=this.__getChartAreaHeight__();var barWidth=this.getBarWidth(xScale);dataSet.enter().append("rect").attr("index","data_"+dataIndex).attr("x",function(d,i){return xScale(i*that.__dataDim__+dataIndex);}).attr("y",height).attr("width",barWidth).attr("height",0).attr("fill",that.getBarsFillColor(dataIndex)).attr("stroke",that.getBarsStrokeColor(dataIndex)).attr("opacity",function(d){return that.__getBarOpacity__((0.0+yScale(d))/height);});if(that.areLabelsVisible(dataIndex)){labelsSet.enter().append("text").attr("index","data_"+dataIndex).text(function(d){return that.__makeLabel__(d,dataIndex);}).attr("text-anchor","middle").attr("x",function(d,i){return xScale(i*that.__dataDim__+dataIndex)+barWidth/2;}).attr("y",height).attr("font-family","sans-serif").attr("font-size",that.getLabelsSize(dataIndex)).attr("fill",that.getLabelColor(dataIndex)).attr("opacity",function(){if(this.getComputedTextLength()<=barWidth){return 1;}else{return 0;}});}else{labelsSet.remove();}return;},writable:false,enumerable:false,configurable:false});Object.defineProperty(basicBarChartSharedPrototype,"__updateDrawing__",{value:function(dataSet,labelsSet,dataIndex,xScale,yScale){var that=this;var height=this.__getChartAreaHeight__();var barWidth=this.getBarWidth(xScale);dataSet.transition().attr("x",function(d,i){return xScale(i*that.__dataDim__+dataIndex);}).attr("y",function(d){return height-yScale(d);}).attr("width",barWidth).attr("height",function(d){return yScale(d);}).attr("opacity",function(d){return that.__getBarOpacity__((0.0+yScale(d))/height);});if(that.areLabelsVisible(dataIndex)){labelsSet.transition().text(function(d){return that.__makeLabel__(d,dataIndex);}).attr("x",function(d,i){return xScale(i*that.__dataDim__+dataIndex)+barWidth/2;}).attr("y",function(d){return height-yScale(d)+15;}).attr("opacity",function(){if(this.getComputedTextLength()<=barWidth){return 1;}else{return 0;}});}else{labelsSet.remove();}return;},writable:false,enumerable:false,configurable:false});basicBarChartSharedPrototype.addProtectedMethod("__refreshDrawing__",function __refreshDrawing__(dataSet,labelsSet,dataIndex,xScale,yScale){var that=this;var height=this.__getChartAreaHeight__();var barWidth=this.getBarWidth(xScale);dataSet.transition().attr("x",function(d,i){return xScale(i*that.__dataDim__+dataIndex);}).attr("y",function(d){return height-yScale(d);}).attr("width",barWidth).attr("height",function(d){return yScale(d);}).attr("fill",that.getBarsFillColor(dataIndex)).attr("stroke",that.getBarsStrokeColor(dataIndex)).attr("opacity",function(d){return that.__getBarOpacity__((0.0+yScale(d))/height);});if(that.areLabelsVisible(dataIndex)){labelsSet.transition().text(function(d){return that.__makeLabel__(d,dataIndex);}).attr("text-anchor","middle").attr("x",function(d,i){return xScale(i*that.__dataDim__+dataIndex)+barWidth/2;}).attr("y",function(d){return height-yScale(d)+15;}).attr("font-family","sans-serif").attr("font-size",that.getLabelsSize(dataIndex)).attr("fill",that.getLabelColor(dataIndex)).attr("opacity",function(){if(this.getComputedTextLength()<=barWidth){return 1;}else{return 0;}});}else{labelsSet.remove();}return;});Object.defineProperty(basicBarChartSharedPrototype,"__onClearData__",{value:function(n){return;},writable:false,enumerable:false,configurable:false});Object.defineProperty(basicBarChartSharedPrototype,"__clearDrawing__",{value:function(dataSet,labelsSet){dataSet.remove();labelsSet.remove();return;},writable:false,enumerable:false,configurable:false});basicBarChartSharedPrototype.addProtectedMethod("__clearHorizontalAxe__",function __clearHorizontalAxe__(){if(this.__horizontalAxe__===null){return;}var axe=this.__horizontalAxe__.svgElement;axe.selectAll("line").remove();axe.selectAll("text").remove();axe.selectAll("svg").remove();return;});basicBarChartSharedPrototype.addProtectedMethod("__drawHorizontalAxeTitle__",function __drawHorizontalAxeTitle__(axe,width,x,y){axe.svgElement.append("svg").attr("x",x).attr("y",y).attr("width",width).attr("height",axe.titleSize+LEGEND_MARGIN);axe.svgElement.select("svg").append("text").attr("type","axe_title").text(axe.title).attr("text-anchor","middle").attr("x",width/2).attr("y",axe.titleSize).attr("fill",axe.titleColor).attr("font-family","sans-serif").attr("font-size",axe.titleSize);});basicBarChartSharedPrototype.addProtectedMethod("__drawHorizontalAxe__",function __drawHorizontalAxe__(){var axe=this.__horizontalAxe__;if(axe===null){return;}var width=axe.svgElement.attr("width"),height=axe.svgElement.attr("height"),notchStep=width/(axe.notches+1);switch(axe.side){case"bottom":axe.svgElement.selectAll("line").data(d3.range(axe.notches+2)).enter().append("svg:line").attr("x1",function(d,i){return i*notchStep;}).attr("y1",0).attr("x2",function(d,i){return i*notchStep;}).attr("y2",NOTCH_LINE_LENGTH).attr("stroke",axe.color).attr("stroke-width",axe.lineWidth);axe.svgElement.append("svg:line").attr("x1",0).attr("y1",0).attr("x2",width).attr("y2",0).attr("stroke",axe.color).attr("stroke-width",axe.lineWidth);if(!Object.isUndefined(axe.title)){this.__drawHorizontalAxeTitle__(axe,width,0,height-axe.titleSize-LEGEND_MARGIN);}break;case"top":axe.svgElement.selectAll("line").data(d3.range(axe.notches+2)).enter().append("svg:line").attr("x1",function(d,i){return i*notchStep;}).attr("y1",height-NOTCH_LINE_LENGTH).attr("x2",function(d,i){return i*notchStep;}).attr("y2",height).attr("stroke",axe.color).attr("stroke-width",axe.lineWidth);axe.svgElement.append("svg:line").attr("x1",0).attr("y1",height).attr("x2",width).attr("y2",height).attr("stroke",axe.color).attr("stroke-width",axe.lineWidth);if(!Object.isUndefined(axe.title)){this.__drawHorizontalAxeTitle__(axe,width,0,LEGEND_MARGIN);}break;default:throw new TypeError("__verticalAxe__ object is invalid");}});basicBarChartSharedPrototype.addProtectedMethod("__clearVerticalAxe__",function __clearVerticalAxe__(){if(this.__verticalAxe__===null){return;}var axe=this.__verticalAxe__.svgElement;axe.selectAll("line").remove();axe.selectAll("text").remove();axe.selectAll("svg").remove();return;});basicBarChartSharedPrototype.addProtectedMethod("__drawVerticalAxeTitle__",function __drawVerticalAxeTitle__(axe,height,x,y,textAngle,textX,textPivot){axe.svgElement.append("svg").attr("x",x).attr("y",0).attr("width",axe.titleSize+LEGEND_MARGIN).attr("height",height);axe.svgElement.select("svg").append("rect").attr("fill",this.getOuterBackgroundColor()).attr("x",0).attr("y",0).attr("width",axe.titleSize).attr("height",height);axe.svgElement.select("svg").append("text").attr("type","axe_title").text(axe.title).attr("text-anchor","middle").attr("x",textX).attr("y",y).attr("transform","rotate("+textAngle+" "+textPivot+","+y+")").attr("fill",axe.titleColor).attr("font-family","sans-serif").attr("font-size",axe.titleSize);});basicBarChartSharedPrototype.addProtectedMethod("__drawVerticalAxe__",function __drawVerticalAxe__(){var axe=this.__verticalAxe__;if(axe===null){return;}var width=axe.svgElement.attr("width"),height=axe.svgElement.attr("height"),notchStep=height/(axe.notches+1);switch(axe.side){case"right":axe.svgElement.selectAll("line").data(d3.range(axe.notches+2)).enter().append("svg:line").attr("x1",0).attr("y1",function(d,i){return i*notchStep;}).attr("x2",NOTCH_LINE_LENGTH).attr("y2",function(d,i){return i*notchStep;}).attr("stroke",axe.color).attr("stroke-width",axe.lineWidth);axe.svgElement.append("svg:line").attr("x1",0).attr("y1",0).attr("x2",0).attr("y2",height).attr("stroke",axe.color).attr("stroke-width",axe.lineWidth);if(!Object.isUndefined(axe.title)){this.__drawVerticalAxeTitle__(axe,height,width-axe.titleSize-LEGEND_MARGIN,height/2,90,LEGEND_MARGIN/2,LEGEND_MARGIN/2);}break;case"left":axe.svgElement.selectAll("line").data(d3.range(axe.notches+2)).enter().append("svg:line").attr("x1",width-NOTCH_LINE_LENGTH).attr("y1",function(d,i){return i*notchStep;}).attr("x2",width).attr("y2",function(d,i){return i*notchStep;}).attr("stroke",axe.color).attr("stroke-width",axe.lineWidth);axe.svgElement.append("svg:line").attr("x1",width).attr("y1",0).attr("x2",width).attr("y2",height).attr("stroke",axe.color).attr("stroke-width",axe.lineWidth);if(!Object.isUndefined(axe.title)){this.__drawVerticalAxeTitle__(axe,height,1,height/2,-90,0,axe.titleSize);}break;default:throw new TypeError("__verticalAxe__ object is invalid");}});Object.defineProperty(basicBarChartSharedPrototype,"__getBarOpacity__",{value:function(val){return 0.25+val*0.75;},writable:false,enumerable:false,configurable:false});basicBarChartSharedPrototype.addProtectedMethod("__makeLabel__",function(val,index,forceAbbreviate){try{if((forceAbbreviate||(!Object.isUndefined(index)&&this.__abbreviatedLabels__[index]))&&Object.isNumber(val)){return ChartUtils.abbreviateNumber(val);}else{return val;}}catch(e){return val;}});basicBarChartSharedPrototype.addProtectedMethod("__updateBackground__",function(){return;});basicBarChartSharedPrototype.addProtectedMethod("__redrawInnerBackground__",function(){this.__chartArea__.select("#innerBackground").attr("fill",this.getInnerBackgroundColor());return;});basicBarChartSharedPrototype.addProtectedMethod("__redrawOuterBackground__",function(){this.__svgElement__.select("#outerBackground").attr("fill",this.getOuterBackgroundColor());try{this.__verticalAxe__.svgElement.selectAll("rect").attr("fill",this.getOuterBackgroundColor());}catch(e){}try{this.__horizontalAxe__.svgElement.selectAll("rect").attr("fill",this.getOuterBackgroundColor());}catch(e){}return;});basicBarChartSharedPrototype.addProtectedMethod("__redrawInnerBorder__",function(border){if(Object.isUndefined(border)){border=this.__innerBorder__;}this.__chartArea__.select("#innerBackground").attr("stroke",border.fill).attr("stroke-width",border.width).attr("stroke-dasharray",border.dash);return;});basicBarChartSharedPrototype.addProtectedMethod("__redrawOuterBorder__",function(border){if(Object.isUndefined(border)){border=this.__outerBorder__;}this.__svgElement__.select("#outerBackground").attr("stroke",border.fill).attr("stroke-width",border.width).attr("stroke-dasharray",border.dash);return;});basicBarChartSharedPrototype.addProtectedMethod("__getWidth__",function(){return parseInt(this.__svgElement__.attr("width"),10);});basicBarChartSharedPrototype.addProtectedMethod("__getHeight__",function(){return parseInt(this.__svgElement__.attr("height"),10);});basicBarChartSharedPrototype.addProtectedMethod("__getChartAreaWidth__",function(){return parseInt(this.__chartArea__.attr("width"),10);});basicBarChartSharedPrototype.addProtectedMethod("__getChartAreaHeight__",function(){return parseInt(this.__chartArea__.attr("height"),10);});basicBarChartSharedPrototype.addProtectedMethod("__decodeCSSMultivalueString__",function __decodeCSSMultivalueString__(str,defaultValue){var values=str.match(/(\d+(px)?\s+)|(\d+(px)?\s*;$)/g);var result,val,i;var keys=["top","right","bottom","left"];if(!values){if(Object.isUndefined(defaultValue)){throw"Illegal Arguments: either at least one value or a default value MUST be supplied";}result={};if(!Object.isUndefined(defaultValue)){for(i=0;i<4;i++){result[keys[i]]=defaultValue;}}return result;}else{values=values.map(function(s){return parseInt(s,10);});}if(!Object.isUndefined(defaultValue)){if(values.length>4){throw"Illegal Argument Exception: CSS string contains too many values.";}result={};for(i=0;i<values.length;i++){result[keys[i]]=values[i];}for(;i<4;i++){result[keys[i]]=defaultValue;}}else{switch(values.length){case 0:result={};break;case 1:val=values[0];result={"top":val,"right":val,"bottom":val,"left":val};break;case 2:result={"top":values[0],"right":values[1],"bottom":values[0],"left":values[1]};break;case 3:result={"top":values[0],"right":values[1],"bottom":values[2],"left":values[1]};break;case 4:result={"top":values[0],"right":values[1],"bottom":values[2],"left":values[3]};break;default:throw"Illegal Argument Exception: CSS string contains too many values.";}}return result;});basicBarChartSharedPrototype.addProtectedMethod("__encodeCSSMultivalueString__",function __encodeCSSMultivalueString__(obj){var values=[];var i,keys=["top","right","bottom","left"];for(i=0;i<4;i++){try{values.push(obj[keys[i]]);}catch(e){break;}}if(values.length>0){return values.join(" ")+";";}else{return"";}});basicBarChartSharedPrototype.addProtectedMethod("__updateAxes__",function __updateAxes__(yScale){var vAxe=this.__verticalAxe__;var i,notches;var axeLabels,m,anchor,labels,x,height,that=this;if(vAxe){if(this.__scaleGlobally__||this.__dataDim__===1){m=this.__maxVals__.max();notches=vAxe.notches;axeLabels=[m];for(i=notches;i>0;i--){axeLabels.push(m*i/(notches+1));}axeLabels.push(0);}else{axeLabels=[];}labels=vAxe.svgElement.selectAll("text[type=axe_label]").data(axeLabels);height=vAxe.svgElement.attr("height");if(vAxe.side==="right"){x=NOTCH_LINE_LENGTH;anchor="start";}else{x=vAxe.svgElement.attr("width")-NOTCH_LINE_LENGTH;anchor="end";}labels.exit().remove();labels.enter().insert("text","svg").attr("type","axe_label").attr("text-anchor",anchor).attr("font-family","sans-serif").attr("font-size",vAxe.labelSize);labels.text(function(d){return that.__makeLabel__(d,undefined,true);}).attr("x",x).attr("y",function(d){return Math.max(vAxe.labelSize*0.75,Math.min(height,height-yScale(d)+vAxe.labelSize*0.375));}).attr("fill",vAxe.color);}return;});basicBarChartSharedPrototype.addProtectedMethod("__initAxes__",function(width,height){this.__svgElement__.insert("rect","#chart_area").attr("id","outerBackground").attr("width",width).attr("height",height).attr("x",0).attr("y",0);var chartWidth=width-this.__margins__.left-this.__margins__.right-2,chartHeight=height-this.__margins__.top-this.__margins__.bottom-2;this.__axeTop__.attr("width",chartWidth).attr("height",this.__margins__.top).attr("x",this.__margins__.left).attr("y",0);this.__axeRight__.attr("width",this.__margins__.right).attr("height",chartHeight).attr("x",width-this.__margins__.right).attr("y",this.__margins__.top+1);this.__axeBottom__.attr("width",chartWidth).attr("height",this.__margins__.bottom).attr("x",this.__margins__.left).attr("y",height-this.__margins__.bottom);this.__axeLeft__.attr("width",this.__margins__.left).attr("height",chartHeight).attr("x",0).attr("y",this.__margins__.top+1);this.__chartArea__.attr("width",chartWidth).attr("height",chartHeight).attr("x",this.__margins__.left+1).attr("y",this.__margins__.top+1);this.__chartArea__.append("rect").attr("id","innerBackground").attr("width",this.__chartArea__.attr("width")).attr("height",this.__chartArea__.attr("height")).attr("x",0).attr("y",0);this.__redrawInnerBackground__();this.__redrawOuterBackground__();this.__redrawInnerBorder__();this.__redrawOuterBorder__();return;});Object.freeze(basicBarChartSharedPrototype);function BasicBarChart(width,height,chartMargins,dataDim,parent){function __initChart__(chart,width,height,chartMargins){if(!chart.__svgElement__||!chart.__divElement__){throw"Inconsitent Chart State: null";}chart.setWidth(width);chart.setHeight(height);if(Object.isUndefined(chartMargins)){chartMargins="";}Object.defineProperty(chart,"__margins__",{value:chart.__decodeCSSMultivalueString__(chartMargins,DEFAULT_AXE_MARGIN),writable:false,enumerable:false,configurable:false});chart.__initAxes__(width,height);var __xScale__=d3.scale.linear().range([0,chart.__getChartAreaWidth__()]);var __yScaleGenerator__=function(){return d3.scale.linear().range([0,chart.__getChartAreaHeight__()]);};Object.defineProperty(chart,"__xScale__",{value:__xScale__,writable:false,enumerable:false,configurable:false});Object.defineProperty(chart,"__yScale__",{value:ChartUtils.fillArray(__yScaleGenerator__,chart.__dataDim__),writable:false,enumerable:false,configurable:false});return;}function __initData__(basicCharObj,dataDim){if(Object.isUndefined(dataDim)){dataDim=1;}else{dataDim=parseInt(dataDim,10);if(isNaN(dataDim)||dataDim<=0){throw"Illegal Argument: dataDim";}else if(dataDim>MAX_SPACE_DIMENSION){throw"Max number of subvalues for each point ("+MAX_SPACE_DIMENSION+") exceeded";}}Object.defineProperty(basicBarChart,"__dataDim__",{value:dataDim,writable:false,enumerable:false,configurable:false});Object.defineProperty(basicBarChart,"__data__",{value:ChartUtils.fillArray(function(){return[];},basicBarChart.__dataDim__),writable:false,enumerable:false,configurable:false});Object.defineProperty(basicBarChart,"__maxVals__",{value:ChartUtils.fillArray(0,basicBarChart.__dataDim__),writable:false,enumerable:false,configurable:false});Object.defineProperty(basicBarChart,"__dataCounter__",{value:0,writable:true,enumerable:false,configurable:false});return;}if(Object.isUndefined(width)||Object.isUndefined(height)){throw"Wrong number of arguments: width and height are mandatory";}if(Object.isUndefined(parent)){parent=d3.select("body");}var div=parent.append("div").attr("id","dynamic_chart_"+next_id);var svg=div.append("svg").attr("id","dynamic_chart_"+next_id);next_id+=1;var basicBarChart=Object.create(basicBarChartSharedPrototype);__initData__(basicBarChart,dataDim);Object.defineProperty(basicBarChart,"__parent__",{value:parent,writable:false,enumerable:false,configurable:false});Object.defineProperty(basicBarChart,"__divElement__",{value:div,writable:false,enumerable:false,configurable:false});Object.defineProperty(basicBarChart,"__svgElement__",{value:svg,writable:false,enumerable:false,configurable:false});Object.defineProperty(basicBarChart,"__chartArea__",{value:svg.append("svg").attr("id","chart_area"),writable:false,enumerable:false,configurable:false});Object.defineProperty(basicBarChart,"__axeLeft__",{value:svg.append("svg").attr("id","axe_left").attr("fill","none"),writable:false,enumerable:false,configurable:false});Object.defineProperty(basicBarChart,"__axeRight__",{value:svg.append("svg").attr("id","axe_right").attr("fill","none"),writable:false,enumerable:false,configurable:false});Object.defineProperty(basicBarChart,"__axeTop__",{value:svg.append("svg").attr("id","axe_top").attr("fill","none"),writable:false,enumerable:false,configurable:false});Object.defineProperty(basicBarChart,"__axeBottom__",{value:svg.append("svg").attr("id","axe_bottom").attr("fill","none"),writable:false,enumerable:false,configurable:false});Object.defineProperty(basicBarChart,"__verticalAxe__",{value:null,writable:true,enumerable:false,configurable:false});Object.defineProperty(basicBarChart,"__horizontalAxe__",{value:null,writable:true,enumerable:false,configurable:false});Object.defineProperty(basicBarChart,"__scaleGlobally__",{value:true,writable:true,enumerable:false,configurable:false});Object.defineProperty(basicBarChart,"__labelsSize__",{value:ChartUtils.fillArray(DEFAULT_LABEL_SIZE,basicBarChart.__dataDim__),writable:false,enumerable:false,configurable:false});Object.defineProperty(basicBarChart,"__labelsVisible__",{value:ChartUtils.fillArray(true,basicBarChart.__dataDim__),writable:false,enumerable:false,configurable:false});Object.defineProperty(basicBarChart,"__abbreviatedLabels__",{value:ChartUtils.fillArray(false,basicBarChart.__dataDim__),writable:false,enumerable:false,configurable:false});Object.defineProperty(basicBarChart,"__barsFillColors__",{value:FILL_COLORS.shallowCopy(basicBarChart.__dataDim__),writable:false,enumerable:false,configurable:false});Object.defineProperty(basicBarChart,"__barsStrokeColors__",{value:ChartUtils.fillArray("black",basicBarChart.__dataDim__),writable:false,enumerable:false,configurable:false});Object.defineProperty(basicBarChart,"__labelColors__",{value:ChartUtils.fillArray("black",basicBarChart.__dataDim__),writable:false,enumerable:false,configurable:false});Object.defineProperty(basicBarChart,"__innerBackgroundColor__",{value:DEFAULT_INNER_BACKGROUND,writable:true,enumerable:false,configurable:false});Object.defineProperty(basicBarChart,"__outerBackgroundColor__",{value:DEFAULT_OUTER_BACKGROUND,writable:true,enumerable:false,configurable:false});Object.defineProperty(basicBarChart,"__innerBorder__",{value:DEFAULT_INNER_BORDER.shallowCopy(),writable:true,enumerable:false,configurable:false});Object.defineProperty(basicBarChart,"__outerBorder__",{value:DEFAULT_OUTER_BORDER.shallowCopy(),writable:true,enumerable:false,configurable:false});Object.defineProperty(basicBarChart,"__legend__",{value:null,writable:true,enumerable:false,configurable:false});__initChart__(basicBarChart,width,height,chartMargins);Object.seal(basicBarChart);return basicBarChart;}function FixedWidthBarChart(ticks,startingPoint,width,height,chartMargins,dataDim,parent){ticks=parseInt(ticks,10);if(isNaN(ticks)||ticks<=0){throw"Illegal Argument: ticks";}var proto=BasicBarChart(width,height,chartMargins,dataDim,parent);var fixedWidthBarChart=Object.create(proto);Object.defineProperty(fixedWidthBarChart,"__ticks__",{value:ticks,writable:false,enumerable:false,configurable:false});Object.defineProperty(fixedWidthBarChart,"__tickLength__",{value:1,writable:true,enumerable:false,configurable:false});Object.defineProperty(fixedWidthBarChart,"__ticksToRemoveOnFullQueue__",{value:0,writable:true,enumerable:false,configurable:false});Object.defineProperty(fixedWidthBarChart,"setFixedDataLengthMode",{value:function(){if(this.hasOwnProperty("__ticksToRemoveOnFullQueue__")){this.__ticksToRemoveOnFullQueue__=0;}else{var proto=this.prototype?this.prototype:this.__proto__;if(proto&&proto.setFixedDataLengthMode){proto.setFixedDataLengthMode();}}return this;},writable:false,enumerable:false,configurable:false});Object.defineProperty(fixedWidthBarChart,"setShifitingDataMode",{value:function(ticksToRemove){ticksToRemove=parseInt(ticksToRemove,10);if(isNaN(ticksToRemove)||ticksToRemove<=0){throw"Illegal Arguments: ticksToRemove";}if(this.hasOwnProperty("__ticksToRemoveOnFullQueue__")){this.__ticksToRemoveOnFullQueue__=ticksToRemove;}else{var proto=this.prototype?this.prototype:this.__proto__;if(proto&&proto.setShifitingDataMode){proto.setShifitingDataMode(ticksToRemove);}}return this;},writable:false,enumerable:true,configurable:false});Object.defineProperty(fixedWidthBarChart,"getBarWidth",{value:function(){return this.__barWidth__;},writable:false,enumerable:true,configurable:false});Object.defineProperty(fixedWidthBarChart,"__canAppendData__",{value:function(newDataArray){if(!Object.isArray(newDataArray)){return[];}var m=this.__getDatasetLength__(),n=this.__ticks__-m;if(newDataArray.length<=n){return newDataArray;}else if(this.__ticksToRemoveOnFullQueue__===0){if(n<=0){return[];}else{return newDataArray.splice(0,n);}}else{m=Math.min(this.__ticksToRemoveOnFullQueue__,m);this.clearData(m);return this.__canAppendData__(newDataArray);}},writable:false,enumerable:false,configurable:false});Object.defineProperty(fixedWidthBarChart,"__drawNewData__",{value:function(dataSet,labelsSet,dataIndex,xScale,yScale){var that=this;var height=this.__getChartAreaHeight__();var barWidth=this.getBarWidth(xScale);dataSet.enter().append("rect").attr("index","data_"+dataIndex).attr("x",function(d,i){return(i*that.__dataDim__+dataIndex)*barWidth;}).attr("y",height).attr("width",barWidth).attr("height",0).attr("fill",that.getBarsFillColor(dataIndex)).attr("stroke",that.getBarsStrokeColor(dataIndex)).attr("opacity",function(d){return that.__getBarOpacity__((0.0+yScale(d))/height);});if(that.areLabelsVisible(dataIndex)&&barWidth>that.getLabelsSize(dataIndex)){labelsSet.enter().append("text").attr("index","data_"+dataIndex).text(function(d){return that.__makeLabel__(d,dataIndex);}).attr("text-anchor","middle").attr("x",function(d,i){return(i*that.__dataDim__+dataIndex+0.5)*barWidth;}).attr("y",height).attr("font-family","sans-serif").attr("font-size",that.getLabelsSize(dataIndex)).attr("fill",that.getLabelColor(dataIndex));}else{labelsSet.remove();}return;},writable:false,enumerable:false,configurable:false});Object.defineProperty(fixedWidthBarChart,"__updateDrawing__",{value:function(dataSet,labelsSet,dataIndex,xScale,yScale){var that=this;var height=this.__getChartAreaHeight__();var barWidth=this.getBarWidth(xScale);dataSet.transition().attr("x",function(d,i){return(i*that.__dataDim__+dataIndex)*barWidth;}).attr("y",function(d){return height-yScale(d);}).attr("width",barWidth).attr("height",function(d){return yScale(d);}).attr("opacity",function(d){return that.__getBarOpacity__((0.0+yScale(d))/height);});if(that.areLabelsVisible(dataIndex)&&barWidth>that.getLabelsSize(dataIndex)){labelsSet.transition().text(function(d){return that.__makeLabel__(d,dataIndex);}).attr("x",function(d,i){return(i*that.__dataDim__+dataIndex+0.5)*barWidth;}).attr("y",function(d){return height-yScale(d)+that.getLabelsSize(dataIndex);});}else{labelsSet.remove();}return;},writable:false,enumerable:false,configurable:false});fixedWidthBarChart.addProtectedMethod("__refreshDrawing__",function __refreshDrawing__(dataSet,labelsSet,dataIndex,xScale,yScale){var that=this;var height=this.__getChartAreaHeight__();var barWidth=this.getBarWidth(xScale);dataSet.transition().attr("x",function(d,i){return(i*that.__dataDim__+dataIndex)*barWidth;}).attr("y",height).attr("width",barWidth).attr("height",0).attr("fill",that.getBarsFillColor(dataIndex)).attr("stroke",that.getBarsStrokeColor(dataIndex)).attr("opacity",function(d){return that.__getBarOpacity__((0.0+yScale(d))/height);});if(that.areLabelsVisible(dataIndex)&&barWidth>that.getLabelsSize(dataIndex)){labelsSet.transition().text(function(d){return that.__makeLabel__(d,dataIndex);}).attr("text-anchor","middle").attr("x",function(d,i){return(i*that.__dataDim__+dataIndex+0.5)*barWidth;}).attr("y",height).attr("font-family","sans-serif").attr("font-size",that.getLabelsSize(dataIndex)).attr("fill",that.getLabelColor(dataIndex));}else{labelsSet.remove();}return;});fixedWidthBarChart.addProtectedMethod("__updateAxes__",function __updateAxes__(yScale){var vAxe=this.__verticalAxe__,hAxe=this.__horizontalAxe__;var i,notches;var axeLabels,m,n,k,anchor,labels,x,y,width,height,scaleFactor,that=this;if(vAxe){if(this.__scaleGlobally__||this.__dataDim__===1){m=this.__maxVals__.max();notches=vAxe.notches;axeLabels=[m];for(i=notches;i>0;i--){axeLabels.push(m*i/(notches+1));}axeLabels.push(0);}else{axeLabels=[];}labels=vAxe.svgElement.selectAll("text[type=axe_label]").data(axeLabels);height=vAxe.svgElement.attr("height");if(vAxe.side==="right"){x=NOTCH_LINE_LENGTH;anchor="start";}else{x=vAxe.svgElement.attr("width")-NOTCH_LINE_LENGTH;anchor="end";}labels.exit().remove();labels.enter().insert("text","svg").attr("type","axe_label").attr("text-anchor",anchor).attr("font-family","sans-serif").attr("font-size",vAxe.labelSize);labels.text(function(d){return that.__makeLabel__(d,undefined,true);}).attr("x",x).attr("y",function(d){return Math.max(vAxe.labelSize*0.75,Math.min(height,height-yScale(d)+vAxe.labelSize*0.375));}).attr("fill",vAxe.color);}if(hAxe){width=hAxe.svgElement.attr("width");height=hAxe.svgElement.attr("height");m=this.__dataCounter__-this.__getDatasetLength__();notches=hAxe.notches;scaleFactor=width/(notches+1);axeLabels=[m];for(i=1;i<=notches;i++){k=m+(this.__ticks__*i/(notches+1));axeLabels.push(k);}axeLabels.push(m+this.__ticks__);labels=hAxe.svgElement.selectAll("text[type=axe_label]").data(axeLabels);if(hAxe.side==="bottom"){y=NOTCH_LINE_LENGTH+hAxe.labelSize;}else{y=height-NOTCH_LINE_LENGTH;anchor="end";}n=0;labels.exit().remove();labels.enter().insert("text","svg").attr("type","axe_label").attr("font-family","sans-serif").attr("text-anchor",function(){++n;return n===1?"start":n===axeLabels.length?"end":"middle";}).attr("font-size",hAxe.labelSize);labels.text(function(d){return Object.isNumber(d)?Math.round(d):d;}).attr("x",function(d,i){return i*scaleFactor;}).attr("y",y).attr("fill",hAxe.color);}return;});function __init__(chart,width,height){var barWidth=width/(chart.__dataDim__*chart.__ticks__);if(barWidth<=0){throw"Illegal Arguments combination: width too small to draw 'ticks' values";}Object.defineProperty(chart,"__barWidth__",{value:barWidth,writable:false,enumerable:false,configurable:false});return;}__init__(fixedWidthBarChart,fixedWidthBarChart.__getChartAreaWidth__(),fixedWidthBarChart.__getChartAreaHeight__());Object.seal(fixedWidthBarChart);return fixedWidthBarChart;}function SlidingBarChart(ticks,width,height,chartMargins,dataDim,parent){ticks=parseInt(ticks,10);if(isNaN(ticks)||ticks<=0){throw"Illegal Argument: ticks";}var DEFAULT_INNER_BACKGROUND_HIGHLIGHT="lightpink";var AXES_LABEL_WIDTH=55;var chartMarginsObj;try{chartMarginsObj=basicBarChartSharedPrototype.__decodeCSSMultivalueString__(chartMargins,undefined);chartMarginsObj.right=Math.max(chartMarginsObj.right,AXES_LABEL_WIDTH);}catch(e){chartMarginsObj={top:0,right:AXES_LABEL_WIDTH};}chartMargins=basicBarChartSharedPrototype.__encodeCSSMultivalueString__(chartMarginsObj);var proto=FixedWidthBarChart(ticks,0,width,height,chartMargins,dataDim,parent);var slidingBarChart=Object.create(proto);Object.defineProperty(slidingBarChart,"__ticksBetweenHighlights__",{value:10,writable:true,enumerable:false,configurable:false});Object.defineProperty(slidingBarChart,"getTicksBetweenHighlights",{value:function(){return this.__ticksBetweenHighlights__;},writable:false,enumerable:true,configurable:false});Object.defineProperty(slidingBarChart,"setTicksBetweenHighlights",{value:function(ticks){if(this.hasOwnProperty("__ticksBetweenHighlights__")){this.__ticksBetweenHighlights__=ticks;}else{var proto=this.prototype?this.prototype:this.__proto__;if(proto&&proto.setTicksBetweenHighlights){proto.setTicksBetweenHighlights(ticks);}}return this;},writable:false,enumerable:true,configurable:false});Object.defineProperty(slidingBarChart,"__backgroundHighlightColor__",{value:DEFAULT_INNER_BACKGROUND_HIGHLIGHT,writable:true,enumerable:false,configurable:false});Object.defineProperty(slidingBarChart,"setInnerBackgroundHighlightColor",{value:function(bgHColor){if(this.hasOwnProperty("__backgroundHighlightColor__")){this.__backgroundHighlightColor__=bgHColor;}else{var proto=this.prototype?this.prototype:this.__proto__;if(proto&&proto.setInnerBackgroundHighlightColor){proto.setInnerBackgroundHighlightColor(bgHColor);}}return this;},writable:false,enumerable:true,configurable:false});Object.defineProperty(slidingBarChart,"getBackgroundHighlightColor",{value:function(){return this.__backgroundHighlightColor__;},writable:false,enumerable:true,configurable:false});Object.defineProperty(slidingBarChart,"__canAppendData__",{value:function(newDataArray){if(!Object.isArray(newDataArray)){return[];}var m=this.__getDatasetLength__(),n=this.__ticks__-m,k=newDataArray.length;if(k>this.__ticks__){newDataArray.splice(0,k-this.__ticks__);k=this.__ticks__;}if(k<=n){return newDataArray;}else{m=Math.min(k,m);this.clearData(m);return newDataArray;}},writable:false,enumerable:false,configurable:false});Object.defineProperty(slidingBarChart,"__selectBackgroundBars__",{value:function(filter){if(Object.isUndefined(filter)){return this.__chartArea__.selectAll("rect[type=back]");}else{return this.__chartArea__.selectAll("rect[type=back]").filter(filter);}},writable:false,enumerable:false,configurable:false});Object.defineProperty(slidingBarChart,"__updateBackground__",{value:function(){var counter=this.__dataCounter__,ticks=this.getTicksBetweenHighlights();var bgColor=this.getInnerBackgroundColor(),bgHColor=this.getBackgroundHighlightColor();this.__selectBackgroundBars__().attr("fill",bgColor);this.__selectBackgroundBars__(function(){return counter>this.d_index&&(counter-this.d_index)%ticks===0;}).attr("fill",bgHColor);return;},writable:false,enumerable:false,configurable:false});slidingBarChart.addProtectedMethod("__updateAxes__",function(yScale){var vAxe=this.__verticalAxe__,hAxe=this.__horizontalAxe__;var i,notches;var axeLabels,m,n,k,anchor,labels,x,y,width,height,scaleFactor,that=this;if(vAxe){if(this.__scaleGlobally__||this.__dataDim__===1){m=this.__maxVals__.max();notches=vAxe.notches;axeLabels=[m];for(i=notches;i>0;i--){axeLabels.push(m*i/(notches+1));}axeLabels.push(0);}else{axeLabels=[];}labels=vAxe.svgElement.selectAll("text[type=axe_label]").data(axeLabels);height=vAxe.svgElement.attr("height");if(vAxe.side==="right"){x=NOTCH_LINE_LENGTH;anchor="start";}else{x=vAxe.svgElement.attr("width")-NOTCH_LINE_LENGTH;anchor="end";}labels.exit().remove();labels.enter().insert("text","svg").attr("type","axe_label").attr("text-anchor",anchor).attr("font-family","sans-serif").attr("font-size",vAxe.labelSize);labels.text(function(d){return that.__makeLabel__(d,undefined,true);}).attr("x",x).attr("y",function(d){return Math.max(vAxe.labelSize*0.75,Math.min(height,height-yScale(d)+vAxe.labelSize*0.375));}).attr("fill",vAxe.color);}if(hAxe){width=hAxe.svgElement.attr("width");height=hAxe.svgElement.attr("height");m=this.__dataCounter__-this.__ticks__;notches=hAxe.notches;scaleFactor=width/(notches+1);axeLabels=[m>=0?m:""];for(i=1;i<=notches;i++){k=m+(this.__ticks__*i/(notches+1));axeLabels.push(k>=0?k:"");}axeLabels.push(this.__dataCounter__);labels=hAxe.svgElement.selectAll("text[type=axe_label]").data(axeLabels);if(hAxe.side==="bottom"){y=NOTCH_LINE_LENGTH+hAxe.labelSize;}else{y=height-NOTCH_LINE_LENGTH;anchor="end";}n=0;labels.exit().remove();labels.enter().insert("text","svg").attr("type","axe_label").attr("font-family","sans-serif").attr("text-anchor",function(){++n;return n===1?"start":n===axeLabels.length?"end":"middle";}).attr("font-size",hAxe.labelSize);labels.text(function(d){return Object.isNumber(d)?Math.round(d):d;}).attr("x",function(d,i){return i*scaleFactor;}).attr("y",y).attr("fill",hAxe.color);}return;});Object.defineProperty(slidingBarChart,"__drawNewData__",{value:function(dataSet,labelsSet,dataIndex,xScale,yScale){var that=this;var height=this.__getChartAreaHeight__();var barWidth=this.getBarWidth(xScale);var initial_x=(this.__ticks__-this.__getDatasetLength__())*that.__dataDim__*barWidth;dataSet.enter().append("rect").attr("index","data_"+dataIndex).attr("x",function(d,i){return initial_x+(i*that.__dataDim__+dataIndex)*barWidth+1;}).attr("y",height).attr("width",barWidth-3).attr("height",0).attr("fill",that.getBarsFillColor(dataIndex)).attr("stroke",that.getBarsStrokeColor(dataIndex)).attr("opacity",function(d){return that.__getBarOpacity__((0.0+yScale(d))/height);});if(that.areLabelsVisible(dataIndex)&&barWidth>that.getLabelsSize(dataIndex)){labelsSet.enter().append("text").attr("index","data_"+dataIndex).text(function(d){return that.__makeLabel__(d,dataIndex);}).attr("text-anchor","middle").attr("x",function(d,i){return initial_x+(i*that.__dataDim__+dataIndex+0.5)*barWidth+1;}).attr("y",height).attr("font-family","sans-serif").attr("font-size",that.getLabelsSize(dataIndex)).attr("fill",that.getLabelColor(dataIndex));}else{labelsSet.remove();}return;},writable:false,enumerable:false,configurable:false});Object.defineProperty(slidingBarChart,"__updateDrawing__",{value:function(dataSet,labelsSet,dataIndex,xScale,yScale){var that=this;var height=this.__getChartAreaHeight__();var barWidth=this.getBarWidth(xScale);var initial_x=(this.__ticks__-this.__getDatasetLength__())*that.__dataDim__*barWidth;dataSet.transition().duration(100).attr("x",function(d,i){return initial_x+(i*that.__dataDim__+dataIndex)*barWidth+1;}).attr("y",function(d){return height-yScale(d);}).attr("width",barWidth-3).attr("height",function(d){return yScale(d);}).attr("opacity",function(d){return that.__getBarOpacity__((0.0+yScale(d))/height);});if(that.areLabelsVisible(dataIndex)&&barWidth>that.getLabelsSize(dataIndex)){labelsSet.transition().text(function(d){return that.__makeLabel__(d,dataIndex);}).attr("x",function(d,i){return initial_x+(i*that.__dataDim__+dataIndex+0.5)*barWidth+1;}).attr("y",function(d){return height-yScale(d)+that.getLabelsSize(dataIndex);});}else{labelsSet.remove();}return;},writable:false,enumerable:false,configurable:false});slidingBarChart.addProtectedMethod("__refreshDrawing__",function __refreshDrawing__(dataSet,labelsSet,dataIndex,xScale,yScale){var that=this;var height=this.__getChartAreaHeight__();var barWidth=this.getBarWidth(xScale);var initial_x=(this.__ticks__-this.__getDatasetLength__())*that.__dataDim__*barWidth;dataSet.transition().attr("index","data_"+dataIndex).attr("x",function(d,i){return initial_x+(i*that.__dataDim__+dataIndex)*barWidth+1;}).attr("y",function(d){return height-yScale(d);}).attr("width",barWidth-3).attr("height",function(d){return yScale(d);}).attr("fill",that.getBarsFillColor(dataIndex)).attr("stroke",that.getBarsStrokeColor(dataIndex)).attr("opacity",function(d){return that.__getBarOpacity__((0.0+yScale(d))/height);});if(that.areLabelsVisible(dataIndex)&&barWidth>that.getLabelsSize(dataIndex)){labelsSet.transition().text(function(d){return that.__makeLabel__(d,dataIndex);}).attr("text-anchor","middle").attr("x",function(d,i){return initial_x+(i*that.__dataDim__+dataIndex+0.5)*barWidth+1;}).attr("y",function(d){return height-yScale(d)+that.getLabelsSize(dataIndex);}).attr("font-family","sans-serif").attr("font-size",that.getLabelsSize(dataIndex)).attr("fill",that.getLabelColor(dataIndex));}else{labelsSet.remove();}return;});slidingBarChart.addProtectedMethod("__redrawInnerBackground__",function(){return;});function __init__(chart,width,height){for(var i=0;i<chart.__dataDim__;i++){chart.toggleLabels(i,false);}var barWidth=width/(chart.__dataDim__*chart.__ticks__);if(barWidth<=0){throw"Illegal Arguments combination: width too small to draw 'ticks' values";}Object.defineProperty(chart,"__barWidth__",{value:barWidth,writable:false,enumerable:false,configurable:false});chart.__chartArea__.select("#innerBackground").attr("fill","white");var totalBarsNumber=chart.__ticks__*chart.__dataDim__;chart.__selectBackgroundBars__().data(new Array(totalBarsNumber)).enter().append("rect").attr("type","back").property("d_index",function(d,i){return Math.floor((totalBarsNumber-i-1)/chart.__dataDim__);}).attr("x",function(d,i){return i*barWidth;}).attr("y",0).attr("width",barWidth-1).attr("height",height).attr("fill",chart.__innerBackgroundColor__);chart.setVerticalAxe(true,"",5,2);return;}__init__(slidingBarChart,slidingBarChart.__getChartAreaWidth__(),slidingBarChart.__getChartAreaHeight__());Object.seal(slidingBarChart);return slidingBarChart;}function TimeWheelChart(ticks,startTime,wheelRadius,width,height,chartMargins,dataDim,parent){var TICK_LINES_LENGTH=5;var BAR_TEXT_MARGIN=5;var proto=FixedWidthBarChart(ticks,0,width,height,chartMargins,dataDim,parent);var timeWheelChart=Object.create(proto);if(ChartUtils.validateTimeString(startTime)){Object.defineProperty(timeWheelChart,"__startTime__",{value:startTime,writable:true,enumerable:false,configurable:false});}Object.defineProperty(timeWheelChart,"__timeWheelLabelsSize__",{value:timeWheelChart.getLabelsSize(0),writable:true,enumerable:false,configurable:false});Object.defineProperty(timeWheelChart,"setTimeWheelLabelsSize",{value:function(size){size=parseInt(size,10);if(isNaN(size)||size<=0){throw"Illegal Argument: size";}if(this.hasOwnProperty("__timeWheelLabelsSize__")){this.__timeWheelLabelsSize__=size;}else{var proto=this.prototype?this.prototype:this.__proto__;if(proto&&proto.setTimeWheelLabelsSize){proto.setTimeWheelLabelsSize(size);}}this.__updateWheelDrawing__();return this;},writable:true,enumerable:false,configurable:false});Object.defineProperty(timeWheelChart,"__timeWheelForeColor__",{value:"lightgrey",writable:true,enumerable:false,configurable:false});timeWheelChart.addPublicMethod("setTimeWheelForeColor",function(color){if(Object.isUndefined(color)||color===null){throw"Illegal Argument: color";}if(this.hasOwnProperty("__timeWheelForeColor__")){this.__timeWheelForeColor__=color;}else{var proto=this.prototype?this.prototype:this.__proto__;if(proto&&proto.setTimeWheelForeColor){proto.setTimeWheelForeColor(color);}}this.__updateWheelDrawing__();return this;});Object.defineProperty(timeWheelChart,"__timeLabelsVisible__",{value:function(){return!Object.isUndefined(this.__startTime__);},writable:false,enumerable:false,configurable:false});timeWheelChart.addPublicMethod("setBarWidth",function(barWidth){barWidth=parseInt(barWidth,10);if(isNaN(barWidth)||barWidth<=0){throw"Illegal Argument: barWidth";}this.__barWidth__=barWidth;return this;});timeWheelChart.addPublicMethod("setWheelCenter",function(cx,cy){cx=parseInt(cx,10);cy=parseInt(cy,10);if(!isNaN(cx)&&!isNaN(cy)){this.__moveWheelCenter__(cx,cy);}else{throw"Illegal Arguments: cx, cy";}return this;});Object.defineProperty(timeWheelChart,"__moveWheelCenter__",{value:function(cx,cy){if(!Object.isNumber(cx)||!Object.isNumber(cy)||(this.__cx__===cx&&this.__cy__===cy)){return;}this.__wheel__.transition().attr("x",cx-this.__r__).attr("y",cy-this.__r__);this.__cx__=cx;this.__cy__=cy;var newDataLength=this.__getDatasetLength__()*this.__dataDim__;var max_val;if(this.__scaleGlobally__){max_val=ChartUtils.fillArray(this.__maxVals__.max(),this.__dataDim__);}else{max_val=this.__maxVals__;}for(var j=0;j<this.__dataDim__;j++){var dataSet=this.__selectData__(this.__data__,j);var labelsSet=this.__selectLabels__(this.__data__,j);this.__xScale__.domain([0,newDataLength]);this.__yScale__[j].domain([0,max_val[j]]);this.__updateDrawing__(dataSet,labelsSet,j,this.__xScale__,this.__yScale__[j]);}return;},writable:false,enumerable:false,configurable:false});Object.defineProperty(timeWheelChart,"__drawNewData__",{value:function(dataSet,labelsSet,dataIndex,xScale,yScale){var that=this;var initial_x=that.__cx__+dataIndex*(that.__barWidth__+1),initial_y=that.__cy__-that.__r__;dataSet.enter().append("rect").attr("index","data_"+dataIndex).attr("x",initial_x).attr("y",initial_y).attr("width",that.__barWidth__).attr("height",0).attr("transform",function(d,i){return"rotate("+(180/Math.PI*(2*i*that.__tickStep__))+" "+that.__cx__+", "+that.__cy__+")";}).attr("fill",that.getBarsFillColor(dataIndex)).attr("stroke",that.getBarsStrokeColor(dataIndex)).attr("opacity",function(d){return that.__getBarOpacity__((0.0+yScale(d))/that.__barHeight__);});if(that.areLabelsVisible(dataIndex)){initial_x+=that.getBarWidth();initial_y-=BAR_TEXT_MARGIN;labelsSet.enter().append("text").attr("index","data_"+dataIndex).text(function(d){return that.__makeLabel__(d,dataIndex);}).attr("text-anchor","left").attr("x",initial_x).attr("y",function(){return initial_y;}).attr("transform",function(d,i){return"rotate("+(180/Math.PI*(2*i*that.__tickStep__))+" "+that.__cx__+", "+that.__cy__+")"+"rotate(-90 "+initial_x+", "+initial_y+")";}).attr("font-family","sans-serif").attr("font-size",that.getLabelsSize(dataIndex)).attr("fill",that.getLabelColor(dataIndex));}else{labelsSet.remove();}return;},writable:false,enumerable:false,configurable:false});Object.defineProperty(timeWheelChart,"__updateDrawing__",{value:function(dataSet,labelsSet,dataIndex,xScale,yScale){var that=this;var initial_x=that.__cx__+dataIndex*(that.__barWidth__+1);dataSet.transition().attr("x",initial_x).attr("y",function(d){return that.__cy__-that.__r__-yScale(d);}).attr("height",function(d){return yScale(d);}).attr("transform",function(d,i){return"rotate("+(180/Math.PI*(2*i*that.__tickStep__))+" "+that.__cx__+", "+that.__cy__+")";}).attr("opacity",function(d){return that.__getBarOpacity__((0.0+yScale(d))/that.__barHeight__);});if(that.areLabelsVisible(dataIndex)){initial_x+=that.getBarWidth();labelsSet.transition().attr("y",function(d){return that.__cy__-that.__r__-yScale(d)-BAR_TEXT_MARGIN;}).attr("x",initial_x).attr("transform",function(d,i){return"rotate("+(180/Math.PI*(2*i*that.__tickStep__))+" "+that.__cx__+", "+that.__cy__+")"+"rotate(-90 "+initial_x+", "+(that.__cy__-that.__r__-yScale(d)-BAR_TEXT_MARGIN)+")";});}else{labelsSet.remove();}return;},writable:false,enumerable:false,configurable:false});timeWheelChart.addProtectedMethod("__refreshDrawing__",function __refreshDrawing__(dataSet,labelsSet,dataIndex,xScale,yScale){var that=this;var initial_x=that.__cx__+dataIndex*(that.__barWidth__+1),initial_y=that.__cy__-that.__r__;dataSet.transition().attr("x",initial_x).attr("y",function(d){return that.__cy__-that.__r__-yScale(d);}).attr("height",function(d){return yScale(d);}).attr("transform",function(d,i){return"rotate("+(180/Math.PI*(2*i*that.__tickStep__))+" "+that.__cx__+", "+that.__cy__+")";}).attr("fill",that.getBarsFillColor(dataIndex)).attr("stroke",that.getBarsStrokeColor(dataIndex)).attr("opacity",function(d){return that.__getBarOpacity__((0.0+yScale(d))/that.__barHeight__);});if(that.areLabelsVisible(dataIndex)){initial_x+=that.getBarWidth();initial_y-=BAR_TEXT_MARGIN;labelsSet.transition().text(function(d){return that.__makeLabel__(d,dataIndex);}).attr("text-anchor","left").attr("x",initial_x).attr("y",function(d){return that.__cy__-that.__r__-yScale(d)-BAR_TEXT_MARGIN;}).attr("transform",function(d,i){return"rotate("+(180/Math.PI*(2*i*that.__tickStep__))+" "+that.__cx__+", "+that.__cy__+")"+"rotate(-90 "+initial_x+", "+(that.__cy__-that.__r__-yScale(d)-BAR_TEXT_MARGIN)+")";}).attr("font-family","sans-serif").attr("font-size",that.getLabelsSize(dataIndex)).attr("fill",that.getLabelColor(dataIndex));}else{labelsSet.remove();}return;});Object.defineProperty(timeWheelChart,"__onClearData__",{value:function(n){this.__timeLabels__.map(function(label){label.text(ChartUtils.addIntToTimeString(label.text(),n));});return;},writable:false,enumerable:false,configurable:false});Object.defineProperty(timeWheelChart,"__updateWheelDrawing__",{value:function(){var that=this;var tmpLabel;this.__timeLabels__.map(function(label){label.attr("fill",that.__timeWheelForeColor__).attr("font-size",that.__timeWheelLabelsSize__);});for(var i=0;i<this.__timeLabels__.length;i++){tmpLabel=this.__timeLabels__[i];switch(tmpLabel.property("clock_time")){case"12":tmpLabel.attr("x",this.__r__).attr("y",TICK_LINES_LENGTH+this.__timeWheelLabelsSize__);break;case"3":tmpLabel.attr("x",2*this.__r__-TICK_LINES_LENGTH-this.__timeLabels__[i].node().getComputedTextLength()).attr("y",this.__r__+this.__timeWheelLabelsSize__/2);break;case"6":tmpLabel.attr("x",this.__r__).attr("y",2*this.__r__-TICK_LINES_LENGTH);break;case"9":tmpLabel.attr("x",TICK_LINES_LENGTH).attr("y",this.__r__+this.__timeWheelLabelsSize__/2);break;}}this.__wheel__.selectAll("line").attr("stroke",this.__timeWheelForeColor__);this.__wheel__.selectAll("circle").attr("stroke",this.__timeWheelForeColor__);return;},writable:false,enumerable:false,configurable:false});timeWheelChart.addProtectedMethod("__updateAxes__",function __updateAxes__(){return;});timeWheelChart.addPublicMethod("setHorizontalAxe",function setHorizontalAxe(){throw"Deprecated Method";});timeWheelChart.addPublicMethod("setVerticalAxe",function setVerticalAxe(){throw"Deprecated Method";});Object.defineProperty(timeWheelChart,"destroy",{value:function(){if(this.__timeLabels__){this.__timeLabels__.length=0;}this.__wheel__.remove();var proto=this.prototype?this.prototype:this.__proto__;if(proto&&proto.destroy){proto.destroy();}return null;},writable:false,enumerable:false,configurable:false});function __init__(chart,width,height,wheelRadius){var __r__,__barHeight__;Object.defineProperty(chart,"__barWidth__",{value:8,writable:true,enumerable:false,configurable:false});Object.defineProperty(chart,"__cx__",{value:width/2,writable:true,enumerable:false,configurable:false});Object.defineProperty(chart,"__cy__",{value:height/2,writable:true,enumerable:false,configurable:false});wheelRadius=parseInt(wheelRadius,10);if(!isNaN(wheelRadius)&&wheelRadius>0){__r__=wheelRadius;__barHeight__=((Math.min(width,height)-2*wheelRadius)/2)*0.75;}else{__barHeight__=Math.min(width,height)/4;__r__=__barHeight__*0.75;}Object.defineProperty(chart,"__r__",{value:__r__,writable:false,enumerable:false,configurable:false});Object.defineProperty(chart,"__barHeight__",{value:__barHeight__,writable:false,enumerable:false,configurable:false});for(var i=0;i<chart.__dataDim__;i++){chart.__yScale__[i].range([0,chart.__barHeight__]);}Object.defineProperty(chart,"__tickStep__",{value:Math.PI/(chart.__ticks__),writable:false,enumerable:false,configurable:false});var initial_x=chart.__cx__-chart.__r__,initial_y=chart.__cy__-chart.__r__;Object.defineProperty(chart,"__wheel__",{value:chart.__chartArea__.append("svg").attr("id","timeWheel").attr("x",initial_x).attr("y",initial_y),writable:false,enumerable:false,configurable:false});chart.__wheel__.append("circle").attr("id","timeWheel").attr("cx",chart.__r__).attr("cy",chart.__r__).attr("stroke",chart.__timeWheelForeColor__).attr("stroke-dasharray","2, 4").attr("fill","none").attr("r",chart.__r__).attr("stroke-width",1);chart.__wheel__.selectAll("line").data(d3.range(chart.__ticks__)).enter().append("svg:line").attr("x1",chart.__r__).attr("y1",0).attr("x2",chart.__r__).attr("y2",TICK_LINES_LENGTH).attr("stroke",chart.__timeWheelForeColor__).attr("transform",function(d,i){return"rotate("+(180/Math.PI*(2*i*chart.__tickStep__))+" "+chart.__r__+", "+chart.__r__+")";});if(chart.__timeLabelsVisible__()){var timeLabels=[];timeLabels.push(chart.__wheel__.append("text").property("clock_time","12").text(chart.__startTime__).attr("font-family","sans-serif").attr("font-size",chart.__timeWheelLabelsSize__).attr("fill",chart.__timeWheelForeColor__).attr("text-anchor","middle").attr("x",chart.__r__).attr("y",TICK_LINES_LENGTH+chart.__timeWheelLabelsSize__));var tmpLabel=chart.__wheel__.append("text").property("clock_time","3").text(ChartUtils.addIntToTimeString(chart.__startTime__,Math.floor(chart.__ticks__/4))).attr("font-family","sans-serif").attr("font-size",chart.__timeWheelLabelsSize__).attr("fill",chart.__timeWheelForeColor__).attr("text-anchor","left");timeLabels.push(tmpLabel);tmpLabel.attr("x",2*chart.__r__-TICK_LINES_LENGTH-tmpLabel.node().getComputedTextLength()).attr("y",chart.__r__+chart.__timeWheelLabelsSize__/2);timeLabels.push(chart.__wheel__.append("text").property("clock_time","6").text(ChartUtils.addIntToTimeString(chart.__startTime__,chart.__ticks__/2)).attr("font-family","sans-serif").attr("font-size",chart.__timeWheelLabelsSize__).attr("fill",chart.__timeWheelForeColor__).attr("text-anchor","middle").attr("x",chart.__r__).attr("y",2*chart.__r__-TICK_LINES_LENGTH));timeLabels.push(chart.__wheel__.append("text").property("clock_time","9").text(ChartUtils.addIntToTimeString(chart.__startTime__,Math.floor(3*chart.__ticks__/4))).attr("font-family","sans-serif").attr("font-size",chart.__timeWheelLabelsSize__).attr("fill",chart.__timeWheelForeColor__).attr("text-anchor","left").attr("x",TICK_LINES_LENGTH).attr("y",chart.__r__+chart.__timeWheelLabelsSize__/2));Object.defineProperty(chart,"__timeLabels__",{value:timeLabels,writable:false,enumerable:false,configurable:false});}return;}__init__(timeWheelChart,timeWheelChart.__getChartAreaWidth__(),timeWheelChart.__getChartAreaHeight__(),wheelRadius);Object.seal(timeWheelChart);return timeWheelChart;}var modulePrototype={BasicBarChart:function(){return BasicBarChart.apply(null,Array.prototype.slice.apply(arguments,[0])).createSafeProxy(true);},FixedWidthBarChart:function(){return FixedWidthBarChart.apply(null,Array.prototype.slice.apply(arguments,[0])).createSafeProxy(true);},SlidingBarChart:function(){return SlidingBarChart.apply(null,Array.prototype.slice.apply(arguments,[0])).createSafeProxy(true);},TimeWheelChart:function(){return TimeWheelChart.apply(null,Array.prototype.slice.apply(arguments,[0])).createSafeProxy(true);}};Object.freeze(modulePrototype);return Object.create(modulePrototype);})();Object.freeze(DynamicChart);}